#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK4x3x52NT4x3x1_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=4, NB=3, KB=52, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + 8;
   const float *stN = B + 6;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 8 - (104*(lda)), incAn = -8;
   const int incBk = (((ldb) << 1)), incBm = -(104*(ldb));
   #define incBn 6
   #define incCm 8
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 8;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0, rB1, rB2;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2;
   ATL_pfl1W(pC0);
   ATL_pfl1W(pC1);
   ATL_pfl1W(pC2);
/*
 * Peel 1st iter to assign C regs
 */
   rA0 = *pA0;
   rB0 = *pB0;
   rA1 = pA0[2];
   rA2 = pA0[4];
   rC0_0 = rA0 * rB0;
   rA3 = pA0[6];
   rB1 = pB0[2];
   rB2 = pB0[4];
   rC1_0 = rA1 * rB0;
   rC2_0 = rA2 * rB0;
   rC3_0 = rA3 * rB0;
   rC0_1 = rA0 * rB1;
   rC1_1 = rA1 * rB1;
   rC2_1 = rA2 * rB1;
   rC3_1 = rA3 * rB1;
   rC0_2 = rA0 * rB2;
   rC1_2 = rA1 * rB2;
   rC2_2 = rA2 * rB2;
   rC3_2 = rA3 * rB2;
   pA0 += incAk;
   pB0 += incBk;
/*
 * Unpeeled K iterations
 */
   for (k=51; k; k--) /* easy loop to unroll */
   {
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rA2 = pA0[4];
      rC0_0 += rA0 * rB0;
      rA3 = pA0[6];
      rB1 = pB0[2];
      rB2 = pB0[4];
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      pA0 += incAk;
      pB0 += incBk;
   }
   rB0 = alpha;
   rC0_0 *= rB0;
   rC0_1 *= rB0;
   rC0_2 *= rB0;
   rC1_0 *= rB0;
   rC1_1 *= rB0;
   rC1_2 *= rB0;
   rC2_0 *= rB0;
   rC2_1 *= rB0;
   rC2_2 *= rB0;
   rC3_0 *= rB0;
   rC3_1 *= rB0;
   rC3_2 *= rB0;
   *pC0 = rC0_0;
   pC0[2] = rC1_0;
   pC0[4] = rC2_0;
   pC0[6] = rC3_0;
   *pC1 = rC0_1;
   pC1[2] = rC1_1;
   pC1[4] = rC2_1;
   pC1[6] = rC3_1;
   *pC2 = rC0_2;
   pC2[2] = rC1_2;
   pC2[4] = rC2_2;
   pC2[6] = rC3_2;
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_cJIK52x3x52NT8x3x1_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=52, NB=3, KB=52, 
 * lda=0, ldb=0, ldc=0, mu=8, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 96;
   const float *stN = B + 6;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 16 - (104*(lda)), incAn = -96;
   const int incBk = (((ldb) << 1)), incBm = -(104*(ldb));
   #define incBn 6
   #define incCm 16
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 96;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7;
   register float rB0, rB1, rB2;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC7_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2, rC7_2;
   do /* M-loop */
   {
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rA2 = pA0[4];
      rC0_0 = rA0 * rB0;
      rA3 = pA0[6];
      rA4 = pA0[8];
      rA5 = pA0[10];
      rA6 = pA0[12];
      rC1_0 = rA1 * rB0;
      rA7 = pA0[14];
      rB1 = pB0[2];
      rB2 = pB0[4];
      rC2_0 = rA2 * rB0;
      rC3_0 = rA3 * rB0;
      rC4_0 = rA4 * rB0;
      rC5_0 = rA5 * rB0;
      rC6_0 = rA6 * rB0;
      rC7_0 = rA7 * rB0;
      rC0_1 = rA0 * rB1;
      rC1_1 = rA1 * rB1;
      rC2_1 = rA2 * rB1;
      rC3_1 = rA3 * rB1;
      rC4_1 = rA4 * rB1;
      rC5_1 = rA5 * rB1;
      rC6_1 = rA6 * rB1;
      rC7_1 = rA7 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC2_2 = rA2 * rB2;
      rC3_2 = rA3 * rB2;
      rC4_2 = rA4 * rB2;
      rC5_2 = rA5 * rB2;
      rC6_2 = rA6 * rB2;
      rC7_2 = rA7 * rB2;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=51; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC0_0 += rA0 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rA5 = pA0[10];
         rA6 = pA0[12];
         rC1_0 += rA1 * rB0;
         rA7 = pA0[14];
         rB1 = pB0[2];
         rB2 = pB0[4];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC5_2 += rA5 * rB2;
         rC6_2 += rA6 * rB2;
         rC7_2 += rA7 * rB2;
         pA0 += incAk;
         pB0 += incBk;
      }
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC1_0 *= rB0;
      rC1_1 *= rB0;
      rC1_2 *= rB0;
      rC2_0 *= rB0;
      rC2_1 *= rB0;
      rC2_2 *= rB0;
      rC3_0 *= rB0;
      rC3_1 *= rB0;
      rC3_2 *= rB0;
      rC4_0 *= rB0;
      rC4_1 *= rB0;
      rC4_2 *= rB0;
      rC5_0 *= rB0;
      rC5_1 *= rB0;
      rC5_2 *= rB0;
      rC6_0 *= rB0;
      rC6_1 *= rB0;
      rC6_2 *= rB0;
      rC7_0 *= rB0;
      rC7_1 *= rB0;
      rC7_2 *= rB0;
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      pC0[4] = rC2_0;
      pC0[6] = rC3_0;
      pC0[8] = rC4_0;
      pC0[10] = rC5_0;
      pC0[12] = rC6_0;
      pC0[14] = rC7_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      pC1[4] = rC2_1;
      pC1[6] = rC3_1;
      pC1[8] = rC4_1;
      pC1[10] = rC5_1;
      pC1[12] = rC6_1;
      pC1[14] = rC7_1;
      *pC2 = rC0_2;
      pC2[2] = rC1_2;
      pC2[4] = rC2_2;
      pC2[6] = rC3_2;
      pC2[8] = rC4_2;
      pC2[10] = rC5_2;
      pC2[12] = rC6_2;
      pC2[14] = rC7_2;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pA0 += incAm;
      pB0 += incBm;
   }
   while(pA0 != stM);
   ATL_cJIK4x3x52NT4x3x1_aX_b0(4, 3, 52, alpha, ca + 96, lda, cb, ldb, beta, cc + 96, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK4x49x52NT4x7x1_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=4, NB=49, KB=52, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=7, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + 8;
   const float *stN = B + 98;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 8 - (104*(lda)), incAn = -8;
   const int incBk = (((ldb) << 1)), incBm = -(104*(ldb));
   #define incBn 14
   #define incCm 8
   const int incCn = (14*(ldc)) - 8;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1)), *pC6=pC5+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3, rC0_4, rC1_4, rC2_4, rC3_4, rC0_5, rC1_5, rC2_5, rC3_5, rC0_6, rC1_6, rC2_6, rC3_6;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
      ATL_pfl1W(pC3);
      ATL_pfl1W(pC4);
      ATL_pfl1W(pC5);
      ATL_pfl1W(pC6);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      rA2 = pA0[4];
      rC0_0 = rA0 * rB0;
      rA3 = pA0[6];
      rB1 = pB0[2];
      rB2 = pB0[4];
      rB3 = pB0[6];
      rC1_0 = rA1 * rB0;
      rB4 = pB0[8];
      rB5 = pB0[10];
      rB6 = pB0[12];
      rC2_0 = rA2 * rB0;
      rC3_0 = rA3 * rB0;
      rC0_1 = rA0 * rB1;
      rC1_1 = rA1 * rB1;
      rC2_1 = rA2 * rB1;
      rC3_1 = rA3 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC2_2 = rA2 * rB2;
      rC3_2 = rA3 * rB2;
      rC0_3 = rA0 * rB3;
      rC1_3 = rA1 * rB3;
      rC2_3 = rA2 * rB3;
      rC3_3 = rA3 * rB3;
      rC0_4 = rA0 * rB4;
      rC1_4 = rA1 * rB4;
      rC2_4 = rA2 * rB4;
      rC3_4 = rA3 * rB4;
      rC0_5 = rA0 * rB5;
      rC1_5 = rA1 * rB5;
      rC2_5 = rA2 * rB5;
      rC3_5 = rA3 * rB5;
      rC0_6 = rA0 * rB6;
      rC1_6 = rA1 * rB6;
      rC2_6 = rA2 * rB6;
      rC3_6 = rA3 * rB6;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=51; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC0_0 += rA0 * rB0;
         rA3 = pA0[6];
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC1_0 += rA1 * rB0;
         rB4 = pB0[8];
         rB5 = pB0[10];
         rB6 = pB0[12];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         rC2_5 += rA2 * rB5;
         rC3_5 += rA3 * rB5;
         rC0_6 += rA0 * rB6;
         rC1_6 += rA1 * rB6;
         rC2_6 += rA2 * rB6;
         rC3_6 += rA3 * rB6;
         pA0 += incAk;
         pB0 += incBk;
      }
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC0_3 *= rB0;
      rC0_4 *= rB0;
      rC0_5 *= rB0;
      rC0_6 *= rB0;
      rC1_0 *= rB0;
      rC1_1 *= rB0;
      rC1_2 *= rB0;
      rC1_3 *= rB0;
      rC1_4 *= rB0;
      rC1_5 *= rB0;
      rC1_6 *= rB0;
      rC2_0 *= rB0;
      rC2_1 *= rB0;
      rC2_2 *= rB0;
      rC2_3 *= rB0;
      rC2_4 *= rB0;
      rC2_5 *= rB0;
      rC2_6 *= rB0;
      rC3_0 *= rB0;
      rC3_1 *= rB0;
      rC3_2 *= rB0;
      rC3_3 *= rB0;
      rC3_4 *= rB0;
      rC3_5 *= rB0;
      rC3_6 *= rB0;
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      pC0[4] = rC2_0;
      pC0[6] = rC3_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      pC1[4] = rC2_1;
      pC1[6] = rC3_1;
      *pC2 = rC0_2;
      pC2[2] = rC1_2;
      pC2[4] = rC2_2;
      pC2[6] = rC3_2;
      *pC3 = rC0_3;
      pC3[2] = rC1_3;
      pC3[4] = rC2_3;
      pC3[6] = rC3_3;
      *pC4 = rC0_4;
      pC4[2] = rC1_4;
      pC4[4] = rC2_4;
      pC4[6] = rC3_4;
      *pC5 = rC0_5;
      pC5[2] = rC1_5;
      pC5[4] = rC2_5;
      pC5[6] = rC3_5;
      *pC6 = rC0_6;
      pC6[2] = rC1_6;
      pC6[4] = rC2_6;
      pC6[6] = rC3_6;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pC4 += incCm;
      pC5 += incCm;
      pC6 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK52x52x52NT0x0x0_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=52, NB=52, KB=52, 
 * lda=0, ldb=0, ldc=0, mu=8, nu=7, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 96;
   const float *stN = B + 98;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 16 - (104*(lda)), incAn = -96;
   const int incBk = (((ldb) << 1)), incBm = -(104*(ldb));
   #define incBn 14
   #define incCm 16
   const int incCn = (14*(ldc)) - 96;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1)), *pC6=pC5+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC7_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2, rC7_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC6_3, rC7_3, rC0_4, rC1_4, rC2_4, rC3_4, rC4_4, rC5_4, rC6_4, rC7_4, rC0_5, rC1_5, rC2_5, rC3_5, rC4_5, rC5_5, rC6_5, rC7_5, rC0_6, rC1_6, rC2_6, rC3_6, rC4_6, rC5_6, rC6_6, rC7_6;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
         ATL_pfl1W(pC5);
         ATL_pfl1W(pC6);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC0_0 = rA0 * rB0;
         rA3 = pA0[6];
         rA4 = pA0[8];
         rA5 = pA0[10];
         rA6 = pA0[12];
         rC1_0 = rA1 * rB0;
         rA7 = pA0[14];
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC2_0 = rA2 * rB0;
         rB4 = pB0[8];
         rB5 = pB0[10];
         rB6 = pB0[12];
         rC3_0 = rA3 * rB0;
         rC4_0 = rA4 * rB0;
         rC5_0 = rA5 * rB0;
         rC6_0 = rA6 * rB0;
         rC7_0 = rA7 * rB0;
         rC0_1 = rA0 * rB1;
         rC1_1 = rA1 * rB1;
         rC2_1 = rA2 * rB1;
         rC3_1 = rA3 * rB1;
         rC4_1 = rA4 * rB1;
         rC5_1 = rA5 * rB1;
         rC6_1 = rA6 * rB1;
         rC7_1 = rA7 * rB1;
         rC0_2 = rA0 * rB2;
         rC1_2 = rA1 * rB2;
         rC2_2 = rA2 * rB2;
         rC3_2 = rA3 * rB2;
         rC4_2 = rA4 * rB2;
         rC5_2 = rA5 * rB2;
         rC6_2 = rA6 * rB2;
         rC7_2 = rA7 * rB2;
         rC0_3 = rA0 * rB3;
         rC1_3 = rA1 * rB3;
         rC2_3 = rA2 * rB3;
         rC3_3 = rA3 * rB3;
         rC4_3 = rA4 * rB3;
         rC5_3 = rA5 * rB3;
         rC6_3 = rA6 * rB3;
         rC7_3 = rA7 * rB3;
         rC0_4 = rA0 * rB4;
         rC1_4 = rA1 * rB4;
         rC2_4 = rA2 * rB4;
         rC3_4 = rA3 * rB4;
         rC4_4 = rA4 * rB4;
         rC5_4 = rA5 * rB4;
         rC6_4 = rA6 * rB4;
         rC7_4 = rA7 * rB4;
         rC0_5 = rA0 * rB5;
         rC1_5 = rA1 * rB5;
         rC2_5 = rA2 * rB5;
         rC3_5 = rA3 * rB5;
         rC4_5 = rA4 * rB5;
         rC5_5 = rA5 * rB5;
         rC6_5 = rA6 * rB5;
         rC7_5 = rA7 * rB5;
         rC0_6 = rA0 * rB6;
         rC1_6 = rA1 * rB6;
         rC2_6 = rA2 * rB6;
         rC3_6 = rA3 * rB6;
         rC4_6 = rA4 * rB6;
         rC5_6 = rA5 * rB6;
         rC6_6 = rA6 * rB6;
         rC7_6 = rA7 * rB6;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=51; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[2];
            rA2 = pA0[4];
            rC0_0 += rA0 * rB0;
            rA3 = pA0[6];
            rA4 = pA0[8];
            rA5 = pA0[10];
            rA6 = pA0[12];
            rC1_0 += rA1 * rB0;
            rA7 = pA0[14];
            rB1 = pB0[2];
            rB2 = pB0[4];
            rB3 = pB0[6];
            rC2_0 += rA2 * rB0;
            rB4 = pB0[8];
            rB5 = pB0[10];
            rB6 = pB0[12];
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC7_1 += rA7 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC6_2 += rA6 * rB2;
            rC7_2 += rA7 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC3_3 += rA3 * rB3;
            rC4_3 += rA4 * rB3;
            rC5_3 += rA5 * rB3;
            rC6_3 += rA6 * rB3;
            rC7_3 += rA7 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC3_4 += rA3 * rB4;
            rC4_4 += rA4 * rB4;
            rC5_4 += rA5 * rB4;
            rC6_4 += rA6 * rB4;
            rC7_4 += rA7 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC3_5 += rA3 * rB5;
            rC4_5 += rA4 * rB5;
            rC5_5 += rA5 * rB5;
            rC6_5 += rA6 * rB5;
            rC7_5 += rA7 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            rC3_6 += rA3 * rB6;
            rC4_6 += rA4 * rB6;
            rC5_6 += rA5 * rB6;
            rC6_6 += rA6 * rB6;
            rC7_6 += rA7 * rB6;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         rC0_6 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC1_4 *= rB0;
         rC1_5 *= rB0;
         rC1_6 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC2_3 *= rB0;
         rC2_4 *= rB0;
         rC2_5 *= rB0;
         rC2_6 *= rB0;
         rC3_0 *= rB0;
         rC3_1 *= rB0;
         rC3_2 *= rB0;
         rC3_3 *= rB0;
         rC3_4 *= rB0;
         rC3_5 *= rB0;
         rC3_6 *= rB0;
         rC4_0 *= rB0;
         rC4_1 *= rB0;
         rC4_2 *= rB0;
         rC4_3 *= rB0;
         rC4_4 *= rB0;
         rC4_5 *= rB0;
         rC4_6 *= rB0;
         rC5_0 *= rB0;
         rC5_1 *= rB0;
         rC5_2 *= rB0;
         rC5_3 *= rB0;
         rC5_4 *= rB0;
         rC5_5 *= rB0;
         rC5_6 *= rB0;
         rC6_0 *= rB0;
         rC6_1 *= rB0;
         rC6_2 *= rB0;
         rC6_3 *= rB0;
         rC6_4 *= rB0;
         rC6_5 *= rB0;
         rC6_6 *= rB0;
         rC7_0 *= rB0;
         rC7_1 *= rB0;
         rC7_2 *= rB0;
         rC7_3 *= rB0;
         rC7_4 *= rB0;
         rC7_5 *= rB0;
         rC7_6 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0[12] = rC6_0;
         pC0[14] = rC7_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC1[4] = rC2_1;
         pC1[6] = rC3_1;
         pC1[8] = rC4_1;
         pC1[10] = rC5_1;
         pC1[12] = rC6_1;
         pC1[14] = rC7_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         pC2[4] = rC2_2;
         pC2[6] = rC3_2;
         pC2[8] = rC4_2;
         pC2[10] = rC5_2;
         pC2[12] = rC6_2;
         pC2[14] = rC7_2;
         *pC3 = rC0_3;
         pC3[2] = rC1_3;
         pC3[4] = rC2_3;
         pC3[6] = rC3_3;
         pC3[8] = rC4_3;
         pC3[10] = rC5_3;
         pC3[12] = rC6_3;
         pC3[14] = rC7_3;
         *pC4 = rC0_4;
         pC4[2] = rC1_4;
         pC4[4] = rC2_4;
         pC4[6] = rC3_4;
         pC4[8] = rC4_4;
         pC4[10] = rC5_4;
         pC4[12] = rC6_4;
         pC4[14] = rC7_4;
         *pC5 = rC0_5;
         pC5[2] = rC1_5;
         pC5[4] = rC2_5;
         pC5[6] = rC3_5;
         pC5[8] = rC4_5;
         pC5[10] = rC5_5;
         pC5[12] = rC6_5;
         pC5[14] = rC7_5;
         *pC6 = rC0_6;
         pC6[2] = rC1_6;
         pC6[4] = rC2_6;
         pC6[6] = rC3_6;
         pC6[8] = rC4_6;
         pC6[10] = rC5_6;
         pC6[12] = rC6_6;
         pC6[14] = rC7_6;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_cJIK52x3x52NT8x3x1_aX_b0(52, 3, 52, alpha, ca, lda, cb + 98, ldb, beta, cc + (98*(ldc)), ldc);
   ATL_cJIK4x49x52NT4x7x1_aX_b0(4, 49, 52, alpha, ca + 96, lda, cb, ldb, beta, cc + 96, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
